 include "settings.inc"
  include "../ti83plus.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON
 EXTERN IGetKey,Quit,PortLog,PortView,USBInfo,Start,IPutS
 EXTERN Stuff,Tools,Demos,About,MouseDemo,KBDDemo,MSDDemo,SilverDemo,PadDemo,DispMainMenu
 EXTERN KBDStuff,DescriptorTool,LogTool,DispDeviceDescriptor,DispConfigDescriptor,DispStringDescriptor
 EXTERN MouseStuff,LogStartTool


 Var MenuJumpTab,2

DoMenu:
       push   af
       B_CALL ClrLCDFull
       B_CALL HomeUp
       pop    af
;       res    appAutoScroll,(iy+appFlags)
       ld     l,a
       ld     h,0
       add    hl,hl
       ld     de,MenuTab
       add    hl,de
       B_CALL LdHLInd
       ld     b,(hl)
       inc    hl     
       ld     (MenuJumpTab),hl
       ld     c,b                  ;C = number of menu items +1
       sla    b
       ld     e,b
       ld     d,0
       add    hl,de                ;hl->string tab
       sra    b
$$:
       push   bc
       call   IPutS
       B_CALL NewLine
       pop    bc
       djnz   $b
       dec    c                    ;C = number of menu items
MenuKeyLoop:
       call   IGetKey
       cp     kQuit
       jp     z,Quit
       cp     kClear
       jr     z,MenuClear
       sub    k1
       cp     c
       jr     nc,MenuKeyLoop
       inc    a
$$:
       add    a,a
       ld     e,a
       ld     d,0
       ld     hl,(MenuJumpTab)
       add    hl,de
       B_CALL LdHLInd
       jp     (hl)
MenuClear:
       xor    a
       jr     $b


;----------------- Menu Data -------------------
 GLOBALS OFF
MenuTab:
       dw     MainMenu             ;menuMain
       dw     DemosMenu            ;menuDemos
       dw     StuffMenu            ;menuStuff
       dw     ToolsMenu            ;menuTools
       dw     DescriptorsMenu      ;menuDescriptors


MainMenu:
       db     6
       dw     Quit
       dw     Stuff
       dw     Tools
       dw     Demos
       dw     About
       dw     Quit
       db     "USB Tools",0
       db     "1) Stuff",0
       db     "2) Tools",0
       db     "3) Demos",0
       db     "4) About",0
       db     "5) Quit",0


DemosMenu:
       db     7
       dw     DispMainMenu
       dw     MouseDemo
       dw     KBDDemo
       dw     PadDemo
       dw     MSDDemo
       dw     SilverDemo
       dw     DispMainMenu
       db     "Demos",0
       db     "1) Mouse Demo",0
       db     "2) KBD Demo",0
       db     "3) Gamepad Demo",0
       db     "4) MSD Demo",0
       db     "5) Silver Demo",0
       db     "6) Back",0

StuffMenu:
       db     4
       dw     DispMainMenu
       dw     KBDStuff
       dw     MouseStuff
       dw     DispMainMenu
       db     "Stuff",0
       db     "1) KBD Action",0
       db     "2) Mouse Action",0
       db     "3) Back",0


ToolsMenu:
       db     5
       dw     DispMainMenu
       dw     DescriptorTool
       dw     LogTool
       dw     LogStartTool
       dw     DispMainMenu
       db     "Tools",0
       db     "1) Descriptors",0
       db     "2) Log Viewer",0
       db     "3) Start Log",0
       db     "4) Back",0


DescriptorsMenu:
       db     5
       dw     Tools
       dw     DispDeviceDescriptor
       dw     DispConfigDescriptor
       dw     DispStringDescriptor
       dw     Tools
       db     "Descriptors",0
       db     "1) Device",0
       db     "2) Config",0
       db     "3) String",0
       db     "4) Back",0
